﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using System.Collections;

namespace HeapSort
{
    public class Heap
    {
        public Heap()
        {
            heap = new ArrayList();
            Node nod = new Node(-1);
            heap.Add(nod);
            delay = 0;
        }

        public class Node
        {
            public Node()
            {
            }

            public Node(int v)
            {
                value = v;
            }

            public int value;
        }

        public frmMain F;
        public ArrayList heap;
        public int delay;

        public void AddNode(int val)
        {
            Node n = new Node(val);
            heap.Add(n);
        }

        public int RemNode()
        {
            Node ret = new Node();
            ret = heap[1] as Node;
            heap.RemoveAt(1);

            Node tmp = new Node();
            tmp = heap[heap.Count] as Node;
            heap.RemoveAt(heap.Count);

            heap.Insert(1, tmp);

            return ret.value;
        }

        public int GetNode(int j)
        {
            return (heap[j] as Node).value;
        }

        //Fa kirajzolása
        public void PaintHeap(Graphics g)
        {
            g.Clear(System.Drawing.SystemColors.Info);

            int elemszam = heap.Count - 1;

            int sz = 1;
            int m = 1;
            while(sz <= elemszam)
            {
                sz = sz * 2;
                m++;
            }

            int j = 1;
            int elem = 1;

            int x = sz / 2;
            int y = 1;

            //Soronként
            for (int i = 1; i <= m; i++ )
            {
                //Sor elemein
                int k = 1;

                x = sz / (j * 2);
                while(k <= j && elem <= elemszam)
                {
                    g.DrawEllipse(new Pen(Color.Black, 1), x * 20, y * 20, 20, 20);

                    Font F = new Font("Arial", 9);
                    SolidBrush drawBrush = new SolidBrush(Color.Black);
                    PointF drawPoint = new PointF(x * 20 + 2, y * 20 + 2);
                    g.DrawString(Convert.ToString( (heap[elem] as Node).value ), F, drawBrush, drawPoint);


                    if (elem * 2 <= elemszam)
                    {
                        int a = x;
                        int b = y;

                        Point Honnan = new System.Drawing.Point(a * 20, b * 20 + 10);
                        Point Hova = new System.Drawing.Point( (a - (sz / j) / 4) * 20 + 10, (b + 1) * 20 );
                        g.DrawLine(new Pen(Color.Black, 1), Honnan, Hova);
                    }
                    
                    if (elem * 2 + 1 <= elemszam)
                    {
                        int a = x;
                        int b = y;

                        Point Honnan = new System.Drawing.Point(a * 20 + 20, b * 20 + 10);
                        Point Hova = new System.Drawing.Point((a + (sz / j) / 4) * 20 + 10, (b + 1) * 20);
                        g.DrawLine(new Pen(Color.Black, 1), Honnan, Hova);
                    }

                    x = x + sz / j;
                    elem++;
                    k++;
                }

                j = j * 2;                                
                y++;
            }
        }

        //Algoritmus + Segéd FV -ek
        public void Csere(int i, int j)
        {
            Node tmp = new Node();
            tmp = heap[i] as Node;
            heap[i] = heap[j];
            heap[j] = tmp;
        }

        public void Sullyeszt(int u, int v, Graphics g)
        {
            int ir;

            bool l = true;
            while (2 * u <= v && l)
            {
                if (2 * u + 1 > v || (heap[2 * u] as Node).value > (heap[2 * u + 1] as Node).value)
                {
                    ir = 2 * u;
                }
                else
                {
                    ir = 2 * u + 1;
                }

                if ((heap[u] as Node).value >= (heap[ir] as Node).value)
                {
                    l = false;
                }
                else
                {
                    Csere(u, ir);
                    u = ir;
                }
                //Kirajzolás várakozás
                PaintHeap(g);
                System.Threading.Thread.Sleep(delay);
            }
        }

        public void KHeap(Graphics g)
        {
            int n = heap.Count - 1;

            for (int i = n / 2; i >= 1; i--)
            {
                Sullyeszt(i, n, g);
            }
        }

        public void HeapSort(Graphics g)
        {
            int n = heap.Count - 1;

            if (n > 1)
            {
                KHeap(g);

                for (int r = n; r >= 2; r--)
                {
                    Csere(1, r);

                    //Kirajzolás várakozás
                    PaintHeap(g);
                    System.Threading.Thread.Sleep(delay);

                    Sullyeszt(1, r - 1, g);
                }
            }
        }

    }
}
