﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using System.IO;

namespace HeapSort
{
    public partial class frmMain : Form
    {
        public Graphics Rajz;
        public Heap h;

        public frmMain()
        {
            InitializeComponent();
            h = new Heap();
            Rajz = Graphics.FromHwnd(panel.Handle);

            // Inicializáló adatok a teszteléshez
            h.AddNode(10);
            h.AddNode(40);
            h.AddNode(1);
            h.AddNode(20);
            h.AddNode(30);
            h.AddNode(11);
            h.AddNode(7);
            h.AddNode(60);
            h.AddNode(34);
            h.AddNode(24);
            h.AddNode(9);

            h.PaintHeap(Rajz);
        }

        private void kilep_Click(object sender, EventArgs e)
        {
            this.Close();
        }

        private void uj_Click(object sender, EventArgs e)
        {
            Rajz.Clear(System.Drawing.SystemColors.Info);
            h = new Heap();
        }

        private void hozzaad_Click(object sender, EventArgs e)
        {
            if(elem.Text != "")
            {
                h.AddNode(Convert.ToInt32(elem.Text));
                h.PaintHeap(Rajz);
                elem.Focus();
                elem.SelectAll();
            }
        }

        private void fullalg_Click(object sender, EventArgs e)
        {
            h.delay = 0;
            h.HeapSort(Rajz);
            h.PaintHeap(Rajz);
        }

        private void trackBar1_ValueChanged(object sender, EventArgs e)
        {
            h.delay = tb.Value;
        }

        private void steppalg_Click(object sender, EventArgs e)
        {
            h.delay = tb.Value * 100;
            h.HeapSort(Rajz);
            h.PaintHeap(Rajz);
        }

        private void ment_Click(object sender, EventArgs e)
        {
            StreamWriter op = new StreamWriter("ment.txt");
            for (int i = 1; i <= h.heap.Count - 1; i++ )
            {
                op.WriteLine( h.GetNode(i) );
            }
            op.Close();            
        }

        private void betolt_Click(object sender, EventArgs e)
        {
            try
            {
                StreamReader ip = new StreamReader("ment.txt");
                h = new Heap();
                while (!ip.EndOfStream)
                {
                    int nod = int.Parse(ip.ReadLine());
                    h.AddNode(nod);
                    System.Threading.Thread.Sleep(tb.Value * 100);
                    h.PaintHeap(Rajz);
                }
                ip.Close();
                h.PaintHeap(Rajz);
            }
            catch (Exception ex)
            {
                MessageBox.Show("Még nem mentettél, így nem tudsz betölteni !");
            }
        }

        private void elem_KeyPress(object sender, KeyPressEventArgs e)
        {
            if (e.KeyChar >= '0' && e.KeyChar <= '9')
            {
                e.Handled = false;
            }
            else
            {
                e.Handled = true;
            }

            if (e.KeyChar == (char)Keys.Return)
            {
                if (elem.Text != "")
                {
                    h.AddNode(Convert.ToInt32(elem.Text));
                    h.PaintHeap(Rajz);
                    elem.Focus();
                    elem.SelectAll();
                }
            }
        }

        private void mutasd_Click(object sender, EventArgs e)
        {
            h.PaintHeap(Rajz);
        }

        private void Form1_Load(object sender, EventArgs e)
        {
            h.PaintHeap(Rajz);
        }

        private void Form1_Activated(object sender, EventArgs e)
        {
            h.PaintHeap(Rajz);
        }

        private void Form1_Shown(object sender, EventArgs e)
        {
            h.PaintHeap(Rajz);
        }
    }
}